from mongoengine import *

from models.Union import Union
from restapi import Methods


class Account(Document):
    meta = {
        'index_background': True,
        'index_cls': False,
        'auto_create_index': True,
        'can_query': True,
        'with_sub_docs': True,
        'methods': [Methods.Get, Methods.List, Methods.Create],
        "indexes": [
            ('bank'),
            ("-bank"),
            ("union"),
            ('union', 'bank', "deleted")
        ],
    }
    union = ReferenceField(Union)
    bank = StringField()
    number = StringField()
    quick_number = StringField()
    deleted = BooleanField(default=False)